﻿Imports System.ComponentModel
Imports Leap
Imports System.Windows.Threading

Public Class kameUpDownRightLeftModel
    Implements INotifyPropertyChanged

    Private ctlr As Controller
    Private listener As LeapListener
    Private dispatcher = Application.Current.Dispatcher

    Public Sub New()
        ctlr = New Controller
        listener = New LeapListener
        ctlr.AddListener(listener)
        AddHandler listener.LeapSwipe, AddressOf Me.SwipeAction
    End Sub

    Private myTop As Double

    Public Property kameTop As Double
        Get
            Return myTop
        End Get
        Set(value As Double)
            myTop = value
            OnPropertyChanged("kameTop")
        End Set
    End Property

    Private myLeft As Double

    Public Property kameLeft As Double
        Get
            Return myLeft
        End Get
        Set(value As Double)
            myLeft = value
            OnPropertyChanged("kameLeft")
        End Set
    End Property

    Private myRight As Double

    Public Property kameRight As Double
        Get
            Return myRight
        End Get
        Set(value As Double)
            myRight = value
            OnPropertyChanged("kameRight")
        End Set
    End Property

    Private myBottom As Double

    Public Property kameBottom As Double
        Get
            Return myBottom
        End Get
        Set(value As Double)
            myBottom = value
            OnPropertyChanged("kameBottom")
        End Set
    End Property

    Private mykameSource As BitmapImage

    Public Property kameSource As BitmapImage
        Get
            Return mykameSource
        End Get
        Set(value As BitmapImage)
            mykameSource = value
            OnPropertyChanged("kameSource")
        End Set
    End Property

    Private Sub SwipeAction(ByVal sd As SwipeDirection)
        Select Case sd
            Case SwipeDirection.Up
                dispatcher.Invoke(Sub()
                                      kameSource = New BitmapImage(New Uri("Images/kame_up.png", UriKind.Relative))
                                      kameTop -= 5
                                  End Sub)


                Exit Select
            Case SwipeDirection.Down
                dispatcher.Invoke(Sub()
                                      kameSource = New BitmapImage(New Uri("Images/kame_down.png", UriKind.Relative))
                                      kameTop += 5
                                  End Sub)


                Exit Select
            Case SwipeDirection.Left
                dispatcher.Invoke(Sub()
                                      'MessageBox.Show("left")
                                      kameSource = New BitmapImage(New Uri("Images/kame_left.png", UriKind.Relative))
                                      kameLeft -= 5
                                  End Sub)


                Exit Select
            Case SwipeDirection.Right
                dispatcher.Invoke(Sub()
                                      'MessageBox.Show("right")
                                      kameSource = New BitmapImage(New Uri("Images/kame_right.png", UriKind.Relative))
                                      kameLeft += 5
                                  End Sub)


                Exit Select
        End Select
    End Sub

    Public Event PropertyChanged(sender As Object, e As PropertyChangedEventArgs) Implements INotifyPropertyChanged.PropertyChanged

    Private Sub OnPropertyChanged(ByVal propertyName As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
    End Sub
End Class
